#!/usr/bin/python3
# -*- coding: utf-8 -*-

####################################################################################
# Projet : traduction du pooler Newtest, du langage Perl vers Python,              #
#        ce script utilise les données récupérées sur les scénarios par le pooler  #
#        Newtest_pooler.py pour les mettre en forme dans un format                 #
#        lisible par l'outil de supervision Nagios                                 #
#                                                                                  #
# Auteur : Sherwin SABRAS (https://www.linkedin.com/in/sherwin-sabras-321164172/)  #
# Date de création : 3 juin 2019                                                   #
#                                                                                  #
# Release : 2019-09-24 YSI  v2.0.1                                                 #
####################################################################################
import sys
import os
import Newtestlib as Ntl
import time
import math
import re

#########################################################################################
#                                                                                       #
#                               Plugin Scenario Version 2 - PYTHON                      #
#                                                                                       #
#########################################################################################


##########################################################################################################
# codes d'erreurs
ERRORS = {'OK': 0, 'WARNING': 1, 'CRITICAL': 2, 'UNKNOWN': 3, 'DEPENDENT': 4}
bool1 = False  # indiquer si l'on a trouvé ou non des scénarios en cours d'exécution sur le robot rbt

##########################################################################################################
def passif():
    # l'état d'exécution du scénario n'est pas connu
    if len(tab_recup_sce[cpt]) == 3:
        Ntl.write_file(RECUP, "[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;AZno information for the couple ({},{})\n".format(t, sce_or_host, rbt, name_sce[cpt], rbt, name_sce[cpt]))
        now = time.ctime()
        Ntl.write_file(LOG, "{}:{}:[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;AZEno information for the couple ({},{})\n".format(now, arg[3], t, sce_or_host, rbt, name_sce[cpt], rbt, name_sce[cpt]))

    # on a des données sur les performances
    elif len(tab_recup_sce[cpt]) == 6:
        # si l'état d'exécution est parmi "Available", "Warning"...
        if tab_recup_sce[cpt][3] in ["Available", "Warning", "Failed", "Canceled", "Unknown"]:

            Ntl.write_file(RECUP, "[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};{};newtest state is {} for the couple ({} ,{}) which send last message at {} | {}\n".format(
                t, sce_or_host, rbt, name_sce[cpt], state[1], tab_recup_sce[cpt][3], rbt, name_sce[cpt], tab_recup_sce[cpt][4], perfdata))
            now = time.ctime()
            Ntl.write_file(LOG, "{}:{}:[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};{};newtest state is {} for the couple ({} ,{}) which send last message at {} | {}\n".format(
                now, arg[3], t, sce_or_host, rbt, name_sce[cpt], state[1], tab_recup_sce[cpt][3], rbt, name_sce[cpt], tab_recup_sce[cpt][4], perfdata))

        else:
            Ntl.write_file(RECUP, "[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;sdgsdno information for the couple ({},{})\n".format(
                t, sce_or_host, rbt, name_sce[cpt], tab_recup_sce[cpt][2], rbt))
            now = time.ctime()
            Ntl.write_file(LOG, "{}:{}:[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;qsfqno information for the couple ({},{})\n".format(
                now, arg[3], t, sce_or_host, rbt, name_sce[cpt], rbt, tab_recup_sce[cpt][2]))

    # pas de données sur les performances
    elif len(tab_recup_sce[cpt]) == 5:
        if tab_recup_sce[cpt][3] in ["Available", "Warning", "Failed", "Canceled", "Unknown"]:  # il n'existe pas de perf
            Ntl.write_file(RECUP, "[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};{};newtest state is {} for the couple ({} ,{}) which send last message at {} \n".format(
                t, sce_or_host, rbt, name_sce[cpt], state[1], tab_recup_sce[cpt][3], rbt, name_sce[cpt], tab_recup_sce[cpt][4]))
            now = time.ctime()
            Ntl.write_file(LOG, "{}:{}:[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};{};newtest state is {} for the couple ({},{}) which send last message at {} \n".format(
                now, arg[3], t, sce_or_host, rbt, name_sce[cpt], state[1], tab_recup_sce[cpt][3], rbt, name_sce[cpt], tab_recup_sce[cpt][4]))

        else:  # pas d'informations sur le couple (robot,scénario) demandé
            Ntl.write_file(RECUP, "[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;AZno information for the couple ({},{})\n".format(t, sce_or_host, rbt, name_sce[cpt], rbt, name_sce[cpt]))
            now = time.ctime()
            Ntl.write_file(LOG, "{}:{}:[{}] PROCESS_SERVICE_CHECK_RESULT;{};{}_{};3;AZEno information for the couple ({},{})\n".format(
                now, arg[3], t, sce_or_host, rbt, name_sce[cpt], rbt, name_sce[cpt]))

##########################################################################################################
def actif():
    now = time.ctime()

    # l'état d'exécution du scénario n'est pas connu
    if len(tab_recup_sce) == 3:
        print("UNKNOWN:newtest state is UNKNOWN for the couple ({},{}) ".format(rbt, sce_or_host))
        Ntl.write_file(LOG, "{}:UNKNOWN:newtest state is UNKNOWN for the couple ({},{}) ".format(now, rbt, sce_or_host))

    # pas de données sur les performances
    elif len(tab_recup_sce) == 5:
        if tab_recup_sce[3] in ["Available", "Warning", "Failed", "Canceled", "Unknown"]:
            print("{}:newtest state is {} for the couple ({},{}) which send last message at {} \n".format(state[0], tab_recup_sce[3], rbt, sce_or_host, tab_recup_sce[4]))
            Ntl.write_file(LOG, "{}:{}:newtest state is {} for the couple ({},{}) which send last message at {} \n".format(now, state[0], tab_recup_sce[3], rbt, sce_or_host, tab_recup_sce[4]))

    # on a des données sur les performances
    elif len(tab_recup_sce) == 6:
        if tab_recup_sce[3] in ["Available", "Warning", "Failed", "Canceled", "Unknown"]:
            print("{}:newtest state is {} for the couple ({},{}) which send last message at {}|{} \n".format(state[0], tab_recup_sce[3], rbt, sce_or_host, tab_recup_sce[4], perfdata))
            Ntl.write_file(LOG, "{}:{}:newtest state is {} for the couple ({},{}) which send last message at {}|{} \n".format(now, state[0], tab_recup_sce[3], rbt, sce_or_host, tab_recup_sce[4], perfdata))

    sys.exit(int(state[1]))

##########################################################################################################
# arguments de la ligne de commande
arg = sys.argv

# chemins d'accès absolu et relatif du fichier courant
full_path = os.path.realpath(__file__)
path = os.path.basename(__file__)

# on supprime le premier argument entré via la ligne de commande
# (correspondant au chemin d'accès (absolu ou relatif) du script exécuté)
if os.path.basename(arg[0]) in [full_path, path]:
    del arg[0]

# s'il manque des arguments, afficher une notice d'utilisation
if len(arg) < 5:
    print("missing argument\n")
    print("usage : program config_file_path pooling_mode( p or a) nmc_addr probe_name scenario_name \n")

# s'il y a trop d'arguments
elif len(arg) > 5:
    print("too many arguments\n")
    sys.exit()

# vérifier qu'il y a suffisamment d'arguments selon le mode choisi (passif ou actif)
param_ok = Ntl.more_param_sce(arg)
if param_ok == "no-ok":
    sys.exit()

else:
    config_file = arg[0]  # chemin du fichier newtest_config
    case = arg[1]  # si arg[1] = p => mode passif ; sinon => mode actif
    #nmc = re.sub('\.', '_', arg[2])  # adresse du nmc
    nmc = arg[2].replace(".", "_")  # adresse du nmc
    rbt = arg[3]  # nom du robot

# si le chemin d'accès vers le fichier de configuration n'existe pas
if not os.path.isfile(config_file):
    print("config file needed. " + config_file + " doesn't exist \n")
    sys.exit()  # quitter

##########################################################################################################
sce_or_host = arg[4]  # scénario (mode actif) or hostname (mode passif)
Ntl.get_config_file(arg[0])  # donner le fichier de configuration à la librairie
param = Ntl.get_param()  # paramètres indiqués dans le fichier de configuration
trace_log = Ntl.get_suffix_preffix_trace_plug_sce()
log = param[2] + trace_log[0] + nmc + trace_log[1]  # fichier trace

# ouvrir le fichier trace (log)
try:
    LOG = open(log, 'a')
except IOError:
    print(" error when opening the file {}\n".format(log))

Ntl.write_file(LOG, "*****{}:plugin_rbt_sce.cgi*****\n".format(arg[3]))
rbt = rbt.upper()  # passer le nom du robot en majuscules

# récupérer les données générées par le pooler
suffix_preffix_file_pooler = Ntl.get_suffix_preffix_file_pooler()
file_pooler = param[2] + suffix_preffix_file_pooler[0] + nmc + suffix_preffix_file_pooler[1]  # le chemin du fichier file_rbt_sce
#print(file_pooler)

# fichier de commande Nagios
file_command_nagios = param[4]  # ex:/usr/local/nagios/var/rw/nagios.cmd

# s'il existe déjà, il est supprimé
if os.path.isfile(file_command_nagios):
    os.unlink(file_command_nagios)
    # ouverture du fichier cmd (mode création / ajout)
    try:
        RECUP = open(file_command_nagios, 'a+')
    except IOError:
        print("error when opening the file {}\n".format(file_command_nagios))

# ouverture du pooler (lecture):
try:
    FILE = open(file_pooler, 'r')
except IOError:
    print(" error when opening the file {}\n".format(file_pooler))

# taille du fichier généré par le pooler
if not os.path.isfile(file_pooler):
    length_file_pooler = 0
else:
    length_file_pooler = os.path.getsize(file_pooler)
    #print(length_file_pooler)

# tant que ce fichier est vide, fermer puis rouvrir le fichier
while length_file_pooler == 0:
    now = time.ctime()  # date et heure
    Ntl.write_file(LOG, "{}:{}:UNKNOWN:file is empty please wait".format(now, arg[3]) + "			******ARGV[3]:Newtest_plugin_rbt.pl*******\n")

    try:
        FILE = open(file_pooler, 'r')
        length_file_pooler = os.path.getsize(file_pooler)

    except:
        print(" error when opening the file {}\n".format(file_pooler))

################## récupération du timestamp #############################################################
# temps Epoch, tronqué à l'unité
t = int(math.floor(time.time()))

##########################################################################################################
# mot-clé pour le mode passif
passif_arg = Ntl.get_passif_arg()
word_for_sce = Ntl.get_word_for_scenario()

# si on a choisi le mode passif
if arg[1] == passif_arg:  # CAS PASSIF

    ###################################### 	CAS PASSIF  (PASSIF CASE) ########################################
    cpt1 = 0  # nombre de lignes dans tab_recup_sce
    tab_recup_sce = []
    now = time.ctime()  # date et heure

    Ntl.write_file(LOG, "{}:{}:passif case\n".format(now, arg[3]))

    # enregistrer les lignes du fichier dans lines
    lines = FILE.readlines()

    # enregistrer dans tab_recup_sce les scénarios exécutés sur le robot rbt
    for line in lines:
        words = re.split(r'\|\|', line)  # récupérer une ligne
        if words[0] == word_for_sce and words[1] == rbt:
            cpt1 += 1
            bool1 = True
            words[-1] = re.sub('\n', '', words[-1])  # retirer le retour chariot en fin de ligne
            words = list(filter(None, words))  # retirer les chaînes de caractères vides
            tab_recup_sce.append(words)

    # si aucun scénario n'a été trouvé pour le robot
    if not bool1:
        print("no scenario for the robot {}\n".format(rbt))
        now = time.ctime()
        Ntl.write_file(LOG, "{}:{}:no scenario for the robot {} \n".format(now, arg[3], rbt))

    name_sce = []

    # enregistrer les noms des scénarios en cours d'exécution sur le robot dans name_sce
    for cpt in range(cpt1):
        # format des performances (il doit y avoir 4 ";")
        # séparer identifiant (numérique) et nom de scénario
        tab_split_id_name = re.split(r'\=+', tab_recup_sce[cpt][2])  # (nom,id)
        name_sce.append(tab_split_id_name[0])

        # si l'état d'exécution du scénario est connu
        if len(tab_recup_sce[cpt]) >= 4:
            state = Ntl.get_nagios_sce_state(tab_recup_sce[cpt][3])

        # si les performances sont disponibles
        if len(tab_recup_sce[cpt]) == 6:
            # remplacer les séparateurs ('!!') par d'autres (';;;')
            perfdata = re.sub(r'\!\!+', ";;;", tab_recup_sce[cpt][5])

        passif()

    RECUP.close()
################################### FIN	CAS PASSIF (END OF PASSIF CASE) ##################################

#########################################  CAS ACTIF  ####################################################
else:  # CAS ACTIF
    sce_or_host = sce_or_host.upper()  # contient le nom du scénario ou du host

    now = time.ctime()  # date et heure

    Ntl.write_file(LOG, "{}:actif case\n".format(now))

    # ouvrir le fichier pooler (mode lecture)
    try:
        FILE = open(file_pooler, 'r')
    except IOError:
        print("error when opening file" + " " + file_pooler)
        sys.exit()

    lines = FILE.readlines()

    # chercher le scénario dans le fichier pooler
    for line in lines:
        words = re.split(r'\|\|', line)  # récupérer une ligne
        # si les noms de scénario et de robot coincident avec une des lignes :
        if words[0] == word_for_sce and words[1] == rbt and words[2][:len(sce_or_host)] == sce_or_host:
            bool1 = True
            words[-1] = re.sub('\n', '', words[-1])  # retirer le retour chariot en fin de ligne
            words = list(filter(None, words))  # retirer les chaînes de caractères vides
            tab_recup_sce = words.copy()  # récupérer la ligne correspondante

    # si le couple (robot,scenario) n'existe pas
    if not bool1:
        print("the couple robot:{}:{} does not exist\n".format(rbt, sce_or_host))
        Ntl.write_file(LOG, "{}:{}:the couple robot:{} scenario:{} does not exist\n".format(now, arg[3], rbt, sce_or_host))
        state = Ntl.get_nagios_sce_state("Unknown") # state UNKNOWN
        sys.exit(int(state[1]))

    else:
        # si l'état d'exécution du scénario est connu
        if len(tab_recup_sce) == 3:
            state = Ntl.get_nagios_sce_state("Unknown") # state UNKNOWN

        if len(tab_recup_sce) >= 4:
            state = Ntl.get_nagios_sce_state(tab_recup_sce[3])  # état d'exécution

        if len(tab_recup_sce) == 6:
            perfdata = re.sub(r'\!\!+', ";;;", tab_recup_sce[5])  # performances
    
        actif()

# fermer les fichiers utilisés
FILE.close()
LOG.close()