#!/usr/bin/php
<?php
$ERROR=array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3);
$SHORT_OPTS="hVw:c:n:s:A:T:D";
$LONG_OPTS=array("help","debug","name:","scenario:",'type:','authfile:','warning:','critical:');
$options = getopt($SHORT_OPTS, $LONG_OPTS);


if ( isset($options["help"]) || isset($options["h"]) ){
	print_help();
	exit($ERROR["OK"]);
}

$name 		= getParam($options,"name","n",null);
$scenario 	= getParam($options,"scenario","s",null);
$warning 	= getParam($options,"warning","w",15);
$critical 	= getParam($options,"critical","c",30);
$type 	    = getParam($options,"type","T","sync");
$authfile 	= getParam($options,"authfile","A",null);
$debug 	    = getParam($options,"debug","D",null);
$extraparams= getParam($options,"args","a",null);
if(isset($debug))
{
    echo "Debug mode enable\n";
    $debug=true;
}
if(empty($authfile))
{
    echo "No authfile\n";
    exit($ERROR['UNKNOWN']);
} 
$params = authFileToArray($authfile);
$folder = $params['folder'];

if($type == 'sync')
{
    $filename= 'Newtest_trace_pooler_'.preg_replace('#\.#','_',$params['ip']).'.txt';
    if(file_exists($folder.$filename))
    {
        $content = file_get_contents($folder.$filename);
        if(preg_match('#"file file_rbt_sce_\.\.\.\"\s:\s+(.*)\n#',$content,$regs))
        {
            $date = trim($regs[1]);
            try 
            {
                //echo $date."\n";
                $lastsync = new DateTime($date);
                $date = new DateTime();
                $now = $date->getTimestamp();
                $delta = $now - $lastsync->getTimestamp();
                $delta = $delta / 60;
                if($delta > $critical)
                {
                    echo "CRITICAL: Last sync was on ".$lastsync->format('d-m-Y H:i:s').' > '.$critical.' min';
                    exit($ERROR['CRITICAL']);
                }
                elseif($delta > $warning)
                {
                    echo "WARNING: Last sync was on ".$lastsync->format('d-m-Y H:i:s').' > '.$warning.' min';
                    exit($ERROR['WARNING']);
                }
                else
                {
                    echo "OK: Last sync was on ".$lastsync->format('d-m-Y H:i:s').' < '.$warning.' min';
                    exit($ERROR['OK']);
                }
            }
            catch (Exception $e) 
            {
                echo 'UNKNOWN: '.$e->getMessage();
                exit($ERROR['UNKNOWN']);
            }
        }
    }
    else
    {
        echo "Sync file no found : $folder".$filename."\n";
        exit($ERROR['UNKNOWN']);
    }
}
function getParam($options,$name1,$name2,$default=null){
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}
function authFileToArray($authfile)
{
    $content = file_get_contents($authfile);
    $arr = explode("\n",$content);
    $authparameter = array();
    foreach($arr as $line)
    {
        if(preg_match('#([a-z]*)\=(.*)#',$line,$regs))
        {
            $authparameter[$regs[1]]=$regs[2];
        }
    }
    return $authparameter;
}
function print_help()
{
	echo"CHECK IP LABEL NEWTEST\n";
	echo "Param:\n";
	echo "\t-n\t--name\t Nom du robot\n";
	echo "\t-s\t--scenario\t  Nom du scenario\n";
	echo "\t-a\t--authfile\t  Fichier d'authentification\n";
	echo "\t-D\t--debug\t  active le mode debug\n";
}
?>
