<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='iplabel'; 
$webp_model='model_'.$webp_name.'.php'; 
//Inclusion des librairie
include_once $path.'common.php';

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin 
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';

//Variable passé en paramètre
$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}
$action='';
if(isset($_GET['action'])&& !empty($_GET['action']))
{
	$action=$_GET['action'];
}
$smarty->assign('tab', $tab);


session_write_close();
try
{
    if($tab=='robots')
    {
        $auth = Model_iplabel::getAuthParameter($dbconnection, $node->getId());
        $rbt_sce = Model_iplabel::getRobotsAndScenarios($auth);
        $robots=$rbt_sce['robots'];
        $smarty->assign('robots', $robots);
        if($action=='addservice')
        {
            $plugin = Model_esia::getPlugin($dbconnection,'CHECK_API_IP_LABEL_ROBOT');
            $plugin = $plugin[0];
            foreach($robots as $robot)
            {
                if(isset($_POST['check-'.$robot['name']]))
                {
                    $param = preg_replace('#<url>#',$auth['ip'],$plugin['parameter']);
                    $param = preg_replace('#<robot>#',$robot['name'],$param);
                    Model_adm::addService($dbconnection,'CHECK_API_IP_LABEL_ROBOT_'.$robot['name'] ,$plugin['id'],$node->getId(),300000,$param,7,null,null,null,null,null);
                }   
            }
            $redirection= $apache_plugin_path.'/control_iplabel.php?nodeid='.$node->getId();
            header('Location: '.$redirection);
            exit(0);
        }
    }
    elseif($tab=='scenarios')
    {
        $auth = Model_iplabel::getAuthParameter($dbconnection, $node->getId());
        $rbt_sce = Model_iplabel::getRobotsAndScenarios($auth);
        $scenarios=$rbt_sce['scenarios'];
        $smarty->assign('scenarios', $scenarios);
        if($action=='addservice')
        {
            $plugin = Model_esia::getPlugin($dbconnection,'CHECK_API_IP_LABEL_SCENARIOS');
            $plugin = $plugin[0];
            foreach($scenarios as $sce)
            {
                $htmlname=$sce['robot'].'-'.$sce['name'];
                if(isset($_POST['check-'.$htmlname]))
                {
                    $param = preg_replace('#<url>#',$auth['ip'],$plugin['parameter']);
                    $param = preg_replace('#<robot>#',$sce['robot'],$param);
                    $param = preg_replace('#<scenario>#',$sce['name'],$param);
                    Model_adm::addService($dbconnection,'CHECK_API_IP_LABEL_SCENARIOS_'.$htmlname,$plugin['id'],$node->getId(),300000,$param,7,null,null,null,null,null);
                }   
            }
            $redirection= $apache_plugin_path.'/control_iplabel.php?nodeid='.$node->getId();
            header('Location: '.$redirection);
            exit(0);
        }
    }
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
$smarty->display($template_path."control_$webp_name.html");
?>
