<?php
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
$ESIA_WIDGET_NOTREE=TRUE;
include_once $path.'common.php';
$webp_name='iplabel'; 
$webp_model='model_'.$webp_name.'.php'; 

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY 
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 */
include_once $path.'/inc/common_node_control.php';
include_once $path.'/Model_adm.php';
//valeur par défaut du show
$show = 'servicestate';
if(isset($_GET['show']) && !empty($_GET['show']))
{
    $show =$_GET['show'];
}
$auth = Model_iplabel::getAuthParameter($dbconnection, $node->getId());
$rbt_sce = Model_iplabel::getRobotsAndScenarios($auth);
$scenarios=$rbt_sce['scenarios'];
$robots=$rbt_sce['robots'];

if($show =="servicestate")
{
    $json = array();
    $json['url']= $auth['ip'];
    $json['robots_number']= count($robots);
    $json['scenarios_number']= count($scenarios);
    $services = Model_esia::getServices($dbconnection,$node->getId());
    foreach($services as $service)
    {
        if($service['check_plugin_name'] == 'CHECK_API_IP_LABEL_SYNC')
        {
            if(preg_match('#Last sync was on\s+(.*)[\>\<]#',$service['stdout'],$regs))
            {
                $json['last_sync'] = $regs[1];
            }
            $real_state='OK';
            switch($service['real_state'])
            {
                case 0: $real_state='OK'; break;
                case 1: $real_state='WARNING'; break;
                case 2: $real_state='CRITICAL'; break;
                case 3: $real_state='UNKNOWN'; break;
                case 4: $real_state='UNKNOWN'; break;
                default: $real_state='UNKNOWN'; break;
            }
            $json['state_sync'] = $real_state;
        }
    }    
    //C3 JS sur les scénarios
    $arr=array();
    $state_sce=array('Available'=>0,'Warning'=>0,'Failed'=>0,'Canceled'=>0,'Unknown'=>0,'OutOfRange'=>0);
    $rbt_sce=array();
    foreach($scenarios as $sce)
    {
        if(empty($sce['state']))
        {
            $state_sce['Unknown']++;
        }
        else
        {
            $name=$sce['state'];
            $state_sce[$name]++;
        }
        if(!array_key_exists($sce['robot'],$rbt_sce))
        {
            $rbt_sce[$sce['robot']]=array('OK'=>0,'NOK'=>0,'state'=>'OK','total'=>0);
        }
        $rbt_sce[$sce['robot']]['total']++;
        if(!empty($sce['state']))
        {
            $rbt = $sce['robot'];
            if($sce['state']=='Available')
            {
                $rbt_sce[$rbt]['OK']++;
            }
            else
            {
                $rbt_sce[$rbt]['NOK']++;
            }
            if($sce['state']=='Warning' && $rbt_sce[$rbt]['state']!='CRITICAL')
            {
                $rbt_sce[$rbt]['state']='WARNING';
            }
            elseif($sce['state']=='Failed' ||  $sce['state']=='Canceled' )
            {
                $rbt_sce[$rbt]['state']='CRITICAL';
            }
            elseif($sce['state']=='Unknown' ||  $sce['state']=='OutOfRange' )
            {
                if($rbt_sce[$rbt]['state']!='WARNING' && $rbt_sce[$rbt]['state']!='CRITICAL')
                {
                    $rbt_sce[$rbt]['state']='UNKNOWN';
                }
            }
        }
        
    }
    foreach($robots as $key => $robot)
    {
        if(array_key_exists($robot['name'],$rbt_sce))
        {
            $robots[$key]['scenarios']=$rbt_sce[$robot['name']];
        }
        else
        {
            $robots[$key]['scenarios']=array('OK'=>0,'NOK'=>0,'state'=>'OK','total'=>0);
        }
    }    
    $json['robots']= $robots;
    $json['robot_scenarios']=$rbt_sce;
    $json['sce_donnut'] = $state_sce;
    echo json_encode($json,true);
}
?>
