<?php
/**
 * @name  Model_XXX
 * @description Classe héritant de "Model_esia" gèrent tout les accès à la base de donnée du plugin Server
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 08/11/2012
 */
include_once SNMP_CLASS;
include_once DEVICE_CLASS;
include_once MVCMODEL;
include_once $path.'/Model_adm.php';

class Model_iplabel extends Model_esia
{

    static public function getAuthParameter($dbconnection, $nodeid)
    {
        $auth="";
        $configs = Model_adm::getAdvanceNodeConfig($dbconnection,$nodeid);
        foreach($configs as $conf)
        {
            if($conf['name'] == 'IPLABEL')
            {
                $auth = Model_iplabel::authFileToArray($conf['file_content']);
            }
        }
        return $auth;
    }
    public static function getRobotsAndScenarios($auth,$rbt=null)
    {
        $folder = $auth['folder'];
        $filename= 'Newtest_file_rbt_sce_'.preg_replace('#\.#','_',$auth['ip']).'.txt';
        $scenarios=array();
        $robots=array();
        if(file_exists($folder.$filename))
        {
            $state_robots=array('OK'=>'OK','SUSPENDED'=>'WARNING','STOPPED'=>'WARNING','UNKNOWN'=>'UNKNOWN','UNINSTALLED'=>'CRITICAL','INOPERATIVE'=>'CRITICAL','RESUME'=>'WARNING');
            $state_sce=array('Available'=>'OK','Warning'=>'WARNING','Failed'=>'CRITICAL','Canceled'=>'CRITICAL','Unknown'=>'UNKNOWN','OutOfRange'=>'UNKNOWN');
            $content = file_get_contents($folder.$filename);
            $content = preg_split('#\n\nSCE#',$content);
            $arr = explode("\n",$content[0]);
            foreach($arr as $line)
            {
                $tmp = explode("||",$line);

                $state_esia = 'OK';
                $lastsync = new DateTime($tmp[3]);
                if(!empty($rbt)) 
                {
                    if($tmp[1]==$rbt)
                    {
                        $robots[]=array('type'=>$tmp[0], 'name'=>$tmp[1],'state'=>$tmp[2],'date'=>$lastsync->format('d-m-Y H:i:s'),'state_esia'=>$state_robots[$tmp[2]]);
                    }
                }
                else
                {
                    $robots[]=array('type'=>$tmp[0], 'name'=>$tmp[1],'state'=>$tmp[2],'date'=>$lastsync->format('d-m-Y H:i:s'),'state_esia'=>$state_robots[$tmp[2]]);
                }     
            }
            $arr = explode("\n",'SCE'.$content[1]);
            foreach($arr as $line)
            {
                $tmp = explode("||",$line);
                $lastsync = new DateTime($tmp[4]);
                $name=explode("=",$tmp[2]);
                if(!empty($rbt))
                {
                    if($tmp[1]==$rbt)
                    {
                        $scenarios[]=array('type'=>$tmp[0], 'robot'=>$tmp[1],'name'=>$name[0],'id'=>$name[1],
                                    'state'=>$tmp[3],'date'=>$lastsync->format('d-m-Y H:i:s'),'data'=>$tmp[5],'state_esia'=>$state_sce[$tmp[3]]);     
                    }
                }
                else
                {
                    $scenarios[]=array('type'=>$tmp[0], 'robot'=>$tmp[1],'name'=>$name[0],'id'=>$name[1],
                                    'state'=>$tmp[3],'date'=>$lastsync->format('d-m-Y H:i:s'),'data'=>$tmp[5],'state_esia'=>$state_sce[$tmp[3]]);     
                }    
            }
        }
        return array('robots'=>$robots,'scenarios'=>$scenarios);
    }

    //
    // Transforme le fichier d'authentification en JSON
    // FICHIER TYPE
    //url=https://nepv4.ip-label.net/nws/ManagementConsoleService.asmx
    /*
    ip=nepv4.ip-label.net
    port=443
    login=esia-sa
    password=XXJKVqqLMoim4pZzKBF9
    newtest_output_folder=/tmp/
    newtest_log_folder=/tmp/
    passive_file=/tmp/test.cmd
    timeout=30
    */
    static public function authFileToArray($content)
    {
        $arr = explode("\n",$content);
        $authparameter = array();
        foreach($arr as $line)
        {
            if(preg_match('#([a-z]*)\=(.*)#',$line,$regs))
            {
                   $authparameter[$regs[1]]=$regs[2];
            }
        }
        return $authparameter;
    }
     static public function arrayToAuthfile($authparameter)
    {
        $string="";
        foreach($authparameter as $key => $value)
        {
            $string .="$key=$value\n";
        }
        return $string;
    }
}
?>
